/* Problem URL: https://codeforces.com/edu/course/2/lesson/7/2/practice/contest/289391/problem/H */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    ll s;
    cin >> n >> m >> s;

    vi dsu(n);
    rep(i, n) {
        dsu[i] = i;
    }

    function<int(int)> find_p = [&](int i) {
        if (dsu[i] == i) {
            return i;
        }
        return dsu[i] = find_p(dsu[i]);
    };

    auto join = [&](int a, int b) {
        a = find_p(a);
        b = find_p(b);

        dsu[b] = a;

        return a != b;
    };

    V<tuple<ll, int, int, int>> edges(m);
    rep(i, m) {
        auto &[c, j, u, v] = edges[i];
        cin >> u >> v >> c;
        u--, v--;
        j = i;
    }

    sort(all(edges), greater<>());

    V<pair<ll, int>> potential;
    for (auto [c, i, u, v] : edges) {
        if (!join(u, v)) {
            potential.emplace_back(c, i);
        }
    }

    rep(i, n) {
        dsu[i] = i;
    }
    reverse(all(potential));

    vi ans;
    ll total = 0;

    for (auto [c, i] : potential) {
        if (total + c > s) {
            break;
        }
        
        ans.push_back(i + 1);
        total += c;
    }

    cout << ans.size() << '\n';
    rep(i, ans.size()) {
        cout << ans[i] << " \n"[i == ans.size() - 1];
    }
}
